import unittest
from LyMaker import LyMk,xmlreader
import os

class testLyMaker(unittest.TestCase):
    
    filename = "testLyMaker"


    def testBasic(self):
        print ("----------------------------")
        print ("basic test with 4/4 offbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test2Q(self):
        print ("----------------------------")
        print("test with 2/4 time offbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(2)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test3Q(self):
        print ("----------------------------")
        print("test with 3/4 time offbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(3)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test5Q(self):
        print ("----------------------------")
        print("test with 5/4 time offbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(5)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test6Q(self):
        print ("----------------------------")
        print("test with 6/4 time offbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(6)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test7Q(self):
        print ("----------------------------")
        print("test with 7/4 time offbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(7)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test9Q(self):
        print ("----------------------------")
        print("test with 9/4 time offbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(9)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def testBasicOn(self):
        print ("----------------------------")
        print("test with 4/4 time onbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setOnbeat(True)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test2QOn(self):
        print ("----------------------------")
        print("test with 2/4 time onbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(2)
        maker.setOnbeat(True)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test3QOn(self):
        print ("----------------------------")
        print("test with 3/4 time onbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(3)
        maker.setOnbeat(True)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test5QOn(self):
        print ("----------------------------")
        print("test with 5/4 time onbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(5)
        maker.setOnbeat(True)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test6QOn(self):
        print ("----------------------------")
        print("test with 6/4 time onbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(6)
        maker.setOnbeat(True)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test7QOn(self):
        print ("----------------------------")
        print("test with 7/4 time onbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(7)
        maker.setOnbeat(True)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def test9QOn(self):
        print ("----------------------------")
        print("test with 9/4 time onbeat")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(9)
        maker.setOnbeat(True)
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def testStrangeDownbeats(self):
        print ("----------------------------")
        print("test with 4/4 time and downbeats 2 and 4")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(4)
        maker.setDownbeats([16,48])
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def testStrangeDownbeatsII(self):
        print ("----------------------------")
        print("test with 4/4 time and downbeats 1 and 2")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(4)
        maker.setDownbeats([0,16])
        content = maker.asXml()
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def testFunky(self):
        print ("----------------------------")
        print("test with 4/4 time and funky feel and bass riff")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(4)
        content = maker.asXml(5,4)
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def testWalking(self):
        print ("----------------------------")
        print("test with 5/4 time and walking bass and high-hat only")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(5)
        content = maker.asXml(1,2)
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def testShuffle(self):
        print ("----------------------------")
        print("test with 4/4 time and shuffle bass and drumpattern")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(4)
        content = maker.asXml(4,5)
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def testEmpty(self):
        print ("----------------------------")
        print("test with 9/4 time and empty bass- and drumline")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(9)
        content = maker.asXml(99,99)
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def testOddBars(self):
        print ("----------------------------")
        print("test with 4/4 time and odd count of bars")
        maker = LyMk.LyMaker(self.filename)
        r = xmlreader.xmlreader(self.filename+ ".xml")
        maker.setQuarters(4)
        content = maker.asXml(2,1,True)
        r.importXML(content)
        text = maker.process(r)
        ok = self._write(text)
        assert ok == True
        cmd = "lilypond %s%s" % (self.filename,".ly") 
        ret = os.system(cmd)
        assert ret == 0

    def _write(self,text):
        outf = None
        try:
            outf = open(self.filename + ".ly","w")
        except:
            print "Cannot open %s" % (self.filename + ".ly")
            return False
        if outf:    
            outf.write(text)
            outf.flush()
            outf.close
            return True




if __name__ == "__main__":
    unittest.main() # run all tests
